//
//  ViewController.m
//  UITableViewDemoZhanKai
//
//  Created by 金鼎玉铉 on 16/8/22.
//  Copyright © 2016年 whjdyx. All rights reserved.
//

#import "ViewController.h"
#import "ShowTableViewCell.h"
@interface ViewController ()<UITableViewDelegate,UITableViewDataSource>
{
    BOOL flag[4];
    BOOL select[15];
    UITableView *tableViewShow;
}
@property (weak, nonatomic) IBOutlet UITableView *XibATableView;
@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    tableViewShow = [[UITableView alloc]initWithFrame:CGRectMake(0, 20, self.view.frame.size.width, self.view.frame.size.height-20) style:UITableViewStyleGrouped];
    tableViewShow.delegate = self;
    tableViewShow.dataSource = self;

    tableViewShow.backgroundColor = [UIColor greenColor];
    [self.view addSubview:tableViewShow];
    
    [tableViewShow registerNib:[UINib nibWithNibName:@"ShowTableViewCell" bundle:nil] forCellReuseIdentifier:@"hoh"];
}
- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (select[indexPath.row + indexPath.section*5] == YES)
    {
        //返回的高度可以根据内容计算，这里没有实现
        return 120;
    }
    return 44;
}
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    if (flag[section] == YES)
    {
        return 5;
    }
    return 0;
}
- (CGFloat)tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section
{
    return 20;
}
- (UIView *)tableView:(UITableView *)tableView viewForHeaderInSection:(NSInteger)section
{
    NSLog(@"当前分区==%ld",section);
    UIButton *btn = [UIButton buttonWithType:UIButtonTypeCustom];
    [btn setTitle:[NSString stringWithFormat:@"展开当前的分区==%ld",section] forState:UIControlStateNormal];
    btn.backgroundColor = [UIColor redColor];
    btn.frame = CGRectMake(0, 0, self.view
                           .frame.size.width, 20);
    [btn setTitle:[NSString stringWithFormat:@"关闭当前的分区==%ld",section] forState:UIControlStateSelected];
    btn.selected = flag[section];
    [btn addTarget:self action:@selector(clickCurrentBtn:) forControlEvents:UIControlEventTouchUpInside];
    btn.tag = section;
    return btn;
}
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    select[indexPath.row +indexPath.section*5] = !select[indexPath.row +indexPath.section*5];
    //单个刷新
    NSIndexPath *indexpath = [NSIndexPath indexPathForRow:indexPath.row inSection:indexPath.section];
    [tableViewShow reloadRowsAtIndexPaths:[NSArray arrayWithObjects:indexpath, nil] withRowAnimation:UITableViewRowAnimationNone];
}
-(NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    
    return 3;
}
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (select[indexPath.section*5 + indexPath.row] == YES)
    {
        ShowTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"hoh" forIndexPath:indexPath];
        cell.headLabel.text = [NSString stringWithFormat:@"当前的头== %ld",indexPath.row];
        
        cell.detailLabel.text = @"花话不是菜，花花是花,想要花花，先买花。。。。。。。";
        return  cell;
    }
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"cell"];
    if (!cell)
    {
        cell = [[UITableViewCell alloc]initWithStyle:UITableViewCellStyleValue1 reuseIdentifier:@"cell"];
    }
    else
    {
        NSLog(@"重用了单元格");
    }
    cell.textLabel.text = [NSString stringWithFormat:@"当前的单元格==%ld",indexPath.row];
    return cell;
}
- (void)clickCurrentBtn:(UIButton *)sender
{
    //整体刷新，建议用上面的单个刷新，这里是提供不同的方法
    flag[sender.tag] = !flag[sender.tag];
    [tableViewShow reloadData];
}
- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
